import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class EauReflection {
  public static void main(String[] args)
      throws NoSuchMethodException, SecurityException,
      IllegalAccessException, IllegalArgumentException,
      InvocationTargetException, InstantiationException {

    Class c = EauChaude6.class;

    System.out.println(
        "c.simpleName = "
        + c.getSimpleName());
    Class s = c.getSuperclass();
    System.out.println(
        "c.superclass.simpleName = "
        + s.getSimpleName());

    Method m1 = c.getMethod("setTemperature", Double.TYPE);
    System.out.println(
          m1.getName() + " viens de "
          + m1.getDeclaringClass().getSimpleName());

    Method m2 = c.getMethod("getEtatφ");

    Object e = c.newInstance();
    m1.invoke(e, Double.valueOf(-5.0));
    Object r = m2.invoke(e);

    System.out.println("r = " + r);
  }
}
