import java.util.Scanner;
public class EauChaude2Bis {
  private static final double ZERO_K = -273.15;
  private double temperature;

  public void setTemperature(double temp) {
    if (temp < ZERO_K)
      throw new IllegalArgumentException(
        "une température < 0 K est impossible !"
      );
    this.temperature = temp;
  }

  public String getEtatφ() {
    return temperature <= 0
      ? "glaçon 🧊"
      : temperature < 100 ?
      "liquide 💦" : "vapeur 💨";
  }

  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    EauChaude2Bis eau = new EauChaude2Bis();
    System.out.println("température ?");
    eau.setTemperature(in.nextDouble());
    System.out.println(eau.getEtatφ());
  }
}
