import java.util.Iterator;

public class Eaux implements Iterable<Eau> {
	private Eau[] eaux;
	public Eaux(Eau...eaux) {
		this.eaux = eaux;
	}
	public Iterator<Eau> iterator() {
		return new Parcourir();
	}
	public class Parcourir implements Iterator<Eau> {
		private int i = 0;
		public boolean hasNext() {
			return i < eaux.length;
		}
		public Eau next() {
			return eaux[i++];
		}
	}
	public static void main(String[] args) {
		Eaux eaux = new Eaux(
			new Eau(-98), new Eau(2), new Eau(102));
		for(Eau eau: eaux)
			System.out.println(eau.getEtatφ());
	}
}
