import java.util.*;
public class EauxPlage implements Iterable<Eau> {
	private final double départ,incr,fin;
	public EauxPlage(double d,double i,double f) {
		départ = d; incr = i; fin = f;
	}
	public Iterator<Eau> iterator() {
		return new Parcourir();
	}
	public class Parcourir implements Iterator<Eau> {
		private double temp = départ;
		public boolean hasNext() {
			return temp < fin;
		}
		public Eau next() {
			Eau eau = new Eau(temp);
			temp += incr;
			return eau;
		}
	}
	public static void main(String[] args) {
		System.out.println("départ incrément fin");
		Scanner in = new Scanner(System.in);
		EauxPlage eaux = new EauxPlage(
			in.nextDouble(),in.nextDouble(),in.nextDouble());
		for(Eau eau: eaux)
			System.out.println(eau.getEtatφ());
	}
}
