public class ParcourirTableau {
	private Eau[] eaux;
	private int i = 0;
	public ParcourirTableau(Eau...eaux) {
		this.eaux = eaux;
	}
	public boolean isFini() {
		return i < eaux.length;
	}
	public Eau suivant() {
		return eaux[i++];
	}
	public static void main(String[] args) {
		Eau[] eaux = {
			new Eau(-98), new Eau(2), new Eau(102) };
		ParcourirTableau iter =
				new ParcourirTableau(eaux);
		while(iter.isFini()) {
			Eau eau = iter.suivant();
			System.out.println(eau.getEtatφ());
		}
	}
}
