import java.util.Iterator;

public class PremiersIter<E> implements Iterator<E> {
	private final Iterator<E> autre;
	private int restant;
	public PremiersIter(Iterator<E> autre,int nombre) {
		this.autre = autre;
		this.restant = nombre;
	}
	public boolean hasNext() {
		return restant > 0;
	}
	public E next() {
		restant--;
		return autre.next();
	}
}
