public class Tableau {
	private Eau[] eaux;
	public Tableau(Eau...eaux) {
		this.eaux = eaux;
	}
	private Parcourir parcourir() {
		return new Parcourir();
	}
	public class Parcourir {
		private int i = 0;
		public boolean isFini() {
			return i < eaux.length;
		}
		public Eau suivant() {
			return eaux[i++];
		}
	}
	public static void main(String[] args) {
		Tableau eaux = new Tableau(
			new Eau(-98), new Eau(2), new Eau(102));
		Parcourir iter = eaux.parcourir();
		while(iter.isFini()) {
			Eau eau = iter.suivant();
			System.out.println(eau.getEtatφ());
		}
	}
}
